/*
 * Copyright (C) 2020, KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
#ifndef CHATDATABASE_H
#define CHATDATABASE_H

#include <memory>
#include <QDateTime>
#include <QVariantList>

class ChatDatabase
{
public:
    ChatDatabase();
    ~ChatDatabase();

    bool insertOne(QString sessionID, int index, QString message);
    bool updateOperateTime(QString sessionID, int index);
    bool deleteBySessionID(QString sessionID);
    bool updateFeedback(QString sessionID, int index, QString message);

    QStringList selectBySessionID(QString sessionID);
    QStringList selectAll();
    QStringList selectAllDialogue();
    int selectMaxHistoryId();
    void updateMaxHistoryId(int history_id);
    static ChatDatabase* getChatDatabase();
private:
    void initBase();
    void createTable();


private:
    class Private;
    std::shared_ptr<Private> d;
};

#endif // CHATDATABASE_H
